api/urls.py
from django.urls import path

from . import views

urlpatterns = [
    path('partners', views.ClientUpdateView.as_view()),
    path('employees', views.BenevoleUpdateView.as_view()),
]

client/urls.py
"""
URLs liés aux clients, communs à 'alarme' et 'transport'
"""
from django.urls import path

from client import views

urlpatterns = [
    path('clients/<str:types>/autocomplete/', views.ClientAutocompleteView.as_view(),
        name='client-autocomplete'),
    path('clients/alertes/', views.ClientAlertesView.as_view(), name='clients-alertes'),

    path('clients/<int:pk>/journal/', views.ClientJournalView.as_view(), name='client-journal'),
    path('clients/<int:pk>/journal/nouveau/', views.ClientJournalEditView.as_view(is_create=True),
        name='client-journal-add'),
    path('clients/<int:pk>/journal/<int:pk_jr>/edition/', views.ClientJournalEditView.as_view(is_create=False),
        name='client-journal-edit'),
    path('clients/<int:pk>/journal/<int:pk_jr>/details/', views.ClientJournalDetailsView.as_view(),
        name='client-journal-details'),
    path('clients/<int:pk>/archive/', views.ClientArchiveView.as_view(), name='client-archive'),

    path('clients/<int:pk>/fichier/nouveau/', views.ClientFichierAddView.as_view(),
        name='client-fichier-add'),
    path('clients/<int:pk>/fichier/liste/', views.ClientFichierListeView.as_view(),
        name='client-fichier-list'),
    path('fichier/<int:pk>/supprimer/', views.ClientFichierDeleteView.as_view(),
        name='client-fichier-delete'),
    # Adresses
    path('clients/<int:pk>/adresse/nouvelle/', views.ClientAdresseEditView.as_view(is_create=True),
        name='client-adresse-add'),
    path('clients/<int:pk>/adresse/<int:pk_adr>/edition/', views.ClientAdresseEditView.as_view(is_create=False),
        name='client-adresse-edit'),
    path('clients/<int:pk>/adresse/<int:pk_adr>/supprimer/', views.ClientAdresseDeleteView.as_view(),
        name='client-adresse-delete'),
    path('clients/<int:pk>/adresse/liste/', views.ClientAdresseListeView.as_view(), name='client-adresse-list'),
    path('clients/<int:pk>/absence/<int:pk_abs>/edition/', views.ClientAbsenceSuiviView.as_view(),
        name='client-absence-edit'),
    # Référents
    path('clients/<int:pk>/referent/nouveau/', views.ReferentEditView.as_view(is_create=True),
        name='client-referent-add'),
    path('clients/<int:pk>/referent/<int:pk_ref>/edition/', views.ReferentEditView.as_view(is_create=False),
        name='client-referent-edit'),
    path('clients/<int:pk>/referent/<int:pk_ref>/supprimer/', views.ReferentDeleteView.as_view(),
        name='client-referent-delete'),
    path('clients/<int:pk>/referent/liste/', views.ClientReferentListeView.as_view(), name='client-referent-list'),
    path('clients/<int:pk>/referent/reorder/', views.ClientReferentReorderView.as_view(typ='référent'),
        name='client-referent-reorder'),
    path('clients/<int:pk>/repondant/reorder/', views.ClientReferentReorderView.as_view(typ='répondant'),
        name='client-repondant-reorder'),
    path('clients/<int:pk>/professionnel/nouveau/', views.ClientProfessionnelAddView.as_view(),
        name='client-professionnel-add'),
    path('clients/<int:pk>/professionnel/<int:pk_ref>/edition/', views.ClientProfessionnelEditView.as_view(),
        name='client-professionnel-edit'),
    path('clients/<int:pk>/professionnel/<int:pk_ref>/supprimer/', views.ClientProfessionnelDeleteView.as_view(),
        name='client-professionnel-delete'),
    path('alerte/<int:pk>/edition/', views.ClientAlerteEditView.as_view(), name='client-alerte-edit'),
    # Samaritains
    path('clients/<int:pk>/set_samas/', views.ClientSetSamaritainsView.as_view(),
        name='client-setsamas'),
    path('clients/<int:pk>/samas/', views.ClientSamaritainsView.as_view(), name='client-samaritains'),
    path('clients/<int:pk>/add_sama/<int:sama_pk>/', views.ClientSamaritainAddView.as_view(), name='client-samas-add'),
    path('clients/<int:pk>/remove_sama/<int:sama_pk>/', views.ClientSamaritainRemoveView.as_view(), name='client-samas-remove'),
    path('clients/<int:pk>/samas_reorder/', views.ClientSamaritainReorderView.as_view(), name='client-samas-reorder'),
    path('clients/<int:pk>/sama/<int:sama_pk>/distance/', views.client_sama_distance, name='client-sama-distance'),
    # Professionnels
    path('professionnels/', views.ProfessionnelListView.as_view(), name='professionnels'),
    path('professionnels/search/', views.ProfessionnelSearchView.as_view(), name='professionel-search'),
    path('professionnels/nouveau/', views.ProfessionnelEditView.as_view(is_create=True), name='professionnel-new'),
    path('professionnels/<int:pk>/edition/', views.ProfessionnelEditView.as_view(is_create=False), name='professionnel-edit'),
    path('professionnels/<int:pk>/archive/', views.ProfessionnelArchiveView.as_view(), name='professionnel-archive'),
]

client/models.py
from datetime import date, timedelta
from operator import attrgetter

from django.apps import apps
from django.contrib.contenttypes.fields import GenericForeignKey, GenericRelation
from django.contrib.contenttypes.models import ContentType
from django.contrib.postgres.fields import ArrayField
from django.core.exceptions import ObjectDoesNotExist, PermissionDenied
from django.db import models, transaction
from django.db.models import Count, Min, Max, OuterRef, Prefetch, Q, Subquery
from django.dispatch import Signal
from django.urls import NoReverseMatch, reverse
from django.utils import timezone

from common.choices import Genres, Handicaps, Languages
from common.fields import ChoiceArrayField, PhoneNumberField
from common.models import GeolocMixin, Fichier, TypeFichier, Utilisateur
from common.utils import canton_app, same_month

# Un signal similaire à post_save, mais envoyé par ReferentEditView, et où les
# instances ReferentTel sont enregistrées.
referent_saved = Signal()


class ClientQuerySet(models.QuerySet):
    def actifs_entre(self, date_deb, date_fin):
        from alarme.models import Installation
        # Sous-requête pour obtenir l'installation la plus récente
        installs = Installation.objects.filter(
            client=OuterRef('pk')
        ).order_by('-date_debut')
        return self.annotate(
            debut_install=Min('installation__date_debut'),
            fin_install=Max('installation__date_fin_abo'),
            en_cours=Count('installation', filter=Q(installation__date_fin_abo__isnull=True)),
            modele=Subquery(installs.values('alarme__modele__nom')[:1]),
        ).filter(
            Q(debut_install__lte=date_fin) & (
                Q(en_cours__gt=0) | Q(fin_install__gte=date_deb)
            )
        )

    def en_age_avs(self):
        year_avs_m = date.today().year - 65
        year_avs_f = date.today().year - 64
        return self.filter(
            Q(tarif_avs_acquis=True) |
            (Q(genre='M') & Q(date_naissance__year__lte=year_avs_m)) |
            (Q(genre='F') & Q(date_naissance__year__lte=year_avs_f))
        )

    def hospitalises(self):
        return self.filter(pk__in=AdressePresence.objects.filter(
            Q(adresse__hospitalisation=True) & (
                Q(jusqua__isnull=True) | (Q(jusqua__gt=date.today()) & Q(depuis__lt=date.today()))
            )
        ).values_list('adresse__client__pk'))


class ClientActifManager(models.Manager):
    def get_queryset(self):
        return ClientQuerySet(self.model, using=self._db).filter(archive_le__isnull=True)


def default_client_type():
    return []


class ClientType(models.TextChoices):
    ALARME = 'alarme', "Alarme"
    TRANSPORT = 'transport', "Transport"
    VISITE = 'visite', "Visite"
    SAVD = 'savd', "SAVD"


class Client(GeolocMixin, models.Model):
    BOITIER_CHOICES = (
        ('prive', 'Privé'),
        ('c-r', 'Croix-Rouge'),
    )
    TYPE_LOGEMENT_CHOICES = (
        ('villa', "Villa"),
        ('appartement', "Appartement"),
        ('resid', "Institution/App. avec encadrement"),
    ) + canton_app.EXTRA_LOGEMENT_CHOICES
    DONNEES_MEDIC_MAP = {
        'troubles_eloc': 'Troubles de l’élocution',
        'troubles_aud': 'Troubles auditifs',
        'allergies': 'Allergies',
        'empl_medic': 'Emplacement des principaux médicaments (p. ex. antiallergiques)',
        'diabete': 'Diabète',
        'troubles_cardio': "Troubles cardiovasculaires",
        'epilepsie': "Epilepsie",
        'oxygene': "Oxygène",
        'anticoag': "Anticoagulant",
        'directives': "Directives anticipées, lieu de dépôt",
        'autres': "Autres données importantes",
    }
    SITUATION_VIE_SEUL = "Seul-e"
    SITUATION_VIE_COUPLE = "En couple"

    id_externe = models.BigIntegerField(null=True, blank=True)
    type_client = ChoiceArrayField(
        models.CharField(max_length=10, choices=ClientType.choices),
        default=default_client_type
    )
    nom = models.CharField("Nom", max_length=60)
    prenom = models.CharField("Prénom", max_length=50)
    genre = models.CharField("Genre", max_length=1, choices=Genres.choices, blank=True)
    date_naissance = models.DateField("Date de naissance", blank=True, null=True)
    nom_part = models.CharField("Nom du partenaire", max_length=50, blank=True)
    prenom_part = models.CharField("Prénom du partenaire", max_length=50, blank=True)
    genre_part = models.CharField("Genre du partenaire", max_length=1, choices=Genres.choices, blank=True)
    date_naissance_part = models.DateField("Date de naissance du partenaire", blank=True, null=True)
    tel_part = PhoneNumberField("Tél. du partenaire", blank=True)
    c_o = models.CharField("C/o", max_length=80, blank=True)
    rue = models.CharField("Rue", max_length=120, blank=True)
    case_postale = models.CharField("Case postale", max_length=20, blank=True)
    npa = models.CharField("NPA", max_length=5)
    localite = models.CharField("Localité", max_length=30)
    # Not using postgis and PointField, as no geometry calculation is done in the db.
    empl_geo = ArrayField(models.FloatField(), size=2, blank=True, null=True)
    tel_1 = PhoneNumberField("Tél. principal", blank=True)
    tel_2 = PhoneNumberField("Tél. secondaire", blank=True)
    courriel = models.EmailField("Courriel", blank=True)
    langues = ChoiceArrayField(
        models.CharField(max_length=2, choices=Languages.choices, blank=True),
        blank=True, null=True
    )
    type_logement = models.CharField("Type de logement", choices=TYPE_LOGEMENT_CHOICES, max_length=12, blank=True)
    type_logement_info = models.CharField("Type de logement", max_length=60, blank=True)
    etage = models.CharField("Étage/niveau", max_length=20, blank=True)
    ascenseur = models.BooleanField("Ascenseur", default=False)
    code_entree = models.CharField("Code entrée immeuble", max_length=20, blank=True)
    nb_pieces = models.CharField("Nbre de pièces", max_length=50, blank=True)
    boitier_cle = models.CharField("Boîtier à clé", max_length=10, choices=BOITIER_CHOICES, blank=True)
    cles = models.CharField("Infos clés", max_length=250, blank=True)
    situation_vie = models.CharField("Situation de vie", max_length=80, blank=True)
    donnees_medic = models.JSONField("Données médicales", blank=True, null=True)
    prest_compl = models.BooleanField("Prestations complémentaires", default=False)
    no_debiteur = models.CharField("N° de débiteur", max_length=30, blank=True)
    no_centrale = models.CharField("N° client de la centrale", max_length=10, blank=True)
    envoi_facture = models.BooleanField("Envoyer une facture", default=True)
    animal_comp = models.CharField("Animal de compagnie", max_length=50, blank=True)
    samaritains = models.PositiveSmallIntegerField("Samaritains comme répondants", blank=True, null=True)
    professionnels = models.ManyToManyField('Professionnel', through='ProfClient', blank=True)
    visiteur = models.ForeignKey(
        'benevole.Benevole', on_delete=models.SET_NULL, null=True, blank=True,
        verbose_name="Bénévole visiteur", related_name="visites"
    )
    spec_alarme = models.TextField("Spécificités du système d'alarme", blank=True)
    remarques_int_alarme = models.TextField("Remarques internes (alarme)", blank=True)
    remarques_int_transport = models.TextField("Remarques internes (transports)", blank=True)
    remarques_int_visite = models.TextField("Remarques internes (visites)", blank=True)
    remarques_ext = models.TextField("Remarques (visibles par bénévoles)", blank=True)
    cree_le = models.DateTimeField("Créé le", auto_now_add=True)
    courrier_envoye = models.DateField(blank=True, null=True)
    archive_le = models.DateField("Archivé le", blank=True, null=True)
    date_deces = models.DateField("Décès le", blank=True, null=True)
    # Pour alarme JU:
    accord_police = models.BooleanField("Accord avant d’envoyer police ou ambulance", default=False)
    # Pour transports:
    handicaps = ChoiceArrayField(
        models.CharField(max_length=10, choices=Handicaps.choices, blank=True),
        blank=True, null=True, verbose_name='Handicaps'
    )
    tarif_avs_acquis = models.BooleanField("Tarif AVS acquis", default=False)
    fonds_transport = models.BooleanField("Fonds Transport handicap", default=False)
    fichiers = GenericRelation(Fichier)

    objects = ClientQuerySet.as_manager()
    actifs = ClientActifManager()

    class Meta:
        db_table = 'alarme_client'
        constraints = [
            models.UniqueConstraint(fields=['id_externe'], name="client_id_externe_unique"),
        ]

    def __str__(self):
        return self.nom_prenom

    def get_absolute_url(self):
        try:
            return (
                reverse('transport-client-detail', args=[self.pk]) if apps.is_installed('transport')
                else reverse('client-edit', args=[self.pk])
            )
        except NoReverseMatch:
            return None

    def can_be_archived(self, user, for_app):
        if self.pk is None or not user.has_perm('client.change_client'):
            return False
        if for_app == 'alarme':
            alarme = self.derniere_alarme()
            if alarme and alarme.retour_mat and alarme.retour_mat < date.today() - timedelta(days=31):
                return True
            elif not alarme and not self.mission_set.filter(effectuee__isnull=True).exists():
                return True
            return False
        elif for_app == 'visite':
            if self.attributions.filter(fin__isnull=True).exists():
                return False
        return True

    def archiver(self, user, for_app, check=True):
        if check and not self.can_be_archived(user, for_app):
            raise PermissionDenied("Il n’est pas possible d’archiver ce client")
        with transaction.atomic():
            if set(self.type_client) in [{for_app}, {for_app, ClientType.SAVD}]:
                self.archive_le = date.today()

client/templates/client/absence_edit.html
{% extends "alarme/general_edit.html" %}
{% load alarme_utils %}

{% block form %}
    <div class="mb-3">
        {% with adresse_str=object.adresse|ligne_adresse %}
            {% if object.adresse.hospitalisation %}À l’hôpital {% if adresse_str %}({{ adresse_str }}){% endif %}
            {% else %}{{ adresse_str }}
            {% endif %}
        {% endwith %}<br>
        Depuis le {{ object.depuis }}
    </div>
    
    {{ block.super }}
{% endblock %}

client/templates/client/adresse_edit.html
{% extends "alarme/general_edit.html" %}

{% block form %}
    {{ block.super }}

    <div class="form-header mb-2"><b>Présences à cette adresse</b></div>
    {{ form.formset.management_form }}
    {% for subform in form.formset.forms %}
        {% for hidden in subform.hidden_fields %}{{ hidden }}{% endfor %}
        <div class="row mb-2">
          <div class="col">
            <div class="form-group">
                {{ subform.depuis.label_tag }} {{ subform.depuis }} {{ subform.depuis.errors }}
            </div>
          </div>
          <div class="col">
            <div class="form-group">
                {{ subform.jusqua.label_tag }} {{ subform.jusqua }} {{ subform.jusqua.errors }}
            </div>
          </div>
        </div>
        <div class="form-group mb-2">
            {{ subform.remarque.label_tag }} {{ subform.remarque }}
            {{ subform.remarque.errors }}
        </div>
    {% endfor %}
{% endblock %}

client/templates/client/alertes_loop.html
{% for alerte in alertes %}
    <div class="row p-2">
        <div class="col-2">
            <a href="{% url 'client-alerte-edit' alerte.pk %}" class="openmodal">{{ alerte.recu_le|date:'d.m.Y H:i' }}</a>
        </div>
        <div class="col">
            <a href="{{ alerte.client.get_absolute_url }}">{{ alerte.client }}</a>,
            {{ alerte.client.npa }} {{ alerte.client.localite }}
            {% if alerte.client_hospitalise %}
            <img class="icon" src="{% static 'img/hopital.svg' %}" title="Cette personne est à l'hôpital" data-bs-toggle="tooltip">
            {% endif %}
        </div>
        <div class="col">
            {% if alerte.fichier %}<a href="{{ alerte.fichier.url }}"><img class="ficon" src="{% static 'ficons/pdf.svg' %}"></a>{% endif %}
            {{ alerte.alerte|linebreaksbr }}
            {% if alerte.rel_object_id %}
            <button type="button" class="btn btn-light btn-icon openmodal" title="Voir/éditer l’intervention"
                    data-modalurl="{% url 'mission-edit' alerte.rel_object_id %}">
                <img class="icon" src="{% static 'img/edit.svg' %}">
            </button>
            {% endif %}
        </div>
        {% if alertes_has_rems %}<div class="col">{{ alerte.remarque }}</div>{% endif %}
    </div>
{% endfor %}

client/templates/client/client_alertes.html
{% extends current_app|add:'/base.html' %}

{% block title %}Liste des clients{% endblock %}

{% block breadcrumb %}
{{ block.super }}
<li class="breadcrumb-item active" aria-current="page">Clients</li>
{% endblock %}

{% block content %}
    {% include 'client/liste_clients_tabs.html' with active='alertes' %}

    <div class="tab-pane fade striped active show" role="tabpanel">
    {% include 'client/alertes_loop.html' with alertes=object_list %}
    </div>
{% endblock %}

client/templates/client/client_journal.html
{% extends "base.html" %}
{% load client_utils %}

{% block title %}{{ client }} - Journal{% endblock %}

{% block breadcrumb %}
<li class="breadcrumb-item"><a href="{% url 'home' %}">Accueil</a></li>
<li class="breadcrumb-item"><a href="{% url 'clients' %}">Clients</a></li>
<li class="breadcrumb-item active" aria-current="page">{{ client|default:"Nouveau client" }}</li>
{% endblock %}

{% block content %}
    <h2>{{ client }} {% services_as_icons client current_app 'p-2' %}</h2>
    <div class="row mt-2 mb-2">
      <div class="col-12 col-md-9">
        {% include current_app|add:'/client_tabs.html' with active='journal' %}
      </div>
      <div class="col-12 col-md-3 text-end">
          <button type="button" class="btn btn-primary openmodal" title="Ajouter une nouvelle note"
                  data-modalurl="{% url 'client-journal-add' client.pk %}">Nouvelle note</button
      </div>
    </div>

    <table class="table">
      <thead>
        <tr>
          <th scope="col" class="quand">Quand</th>
          <th scope="col" class="qui">Qui</th>
          <th scope="col">Description</th>
        </tr>
      </thead>
      <tbody>
        {% for entry in object_list %}
        <tr>
          <td>{{ entry.quand|date:'d.m.Y H:i' }}</th>
          <td>{{ entry.qui.get_full_name }}</td>
          <td>
            {% if entry.fichier %}<a href="{% url 'media' entry.fichier %}">{% endif %}
            {{ entry.description|safe }}
            {% if entry.fichier %}</a>{% endif %}
            {% if entry.details %}
                <i><a href="{% url 'client-journal-details' client.pk entry.pk %}" class="openmodal" title="Afficher les détails">Détails</a></i>
            {% endif %}
          </td>
          <td>{% if entry|can_edit:request.user %}
              <button type="button" class="btn btn-light btn-icon openmodal" title="Modifier la note"
                    data-modalurl="{% url 'client-journal-edit' client.pk entry.pk %}"><img src="{% static 'img/edit.svg' %}"></button>
              {% endif %}
          </td>
        </tr>
        {% endfor %}
      </tbody>
    </table>

    {% include 'pagination.html' %}
{% endblock %}

client/templates/client/contact_list.html
{# readonly is set when including this template #}
{% if repondants %}<h4>Répondants :</h4>{% endif %}
<div class="list-group contact-list-orderable" data-reorder="{% url 'client-repondant-reorder' client.pk %}"
     data-confirm="Souhaitez-vous vraiment changer l’ordre des répondants ? La modification sera immédiatement enregistrée.">
    {% for contact in repondants %}
        {% if contact.sama %}
        <div class="list-group-item list-group-item-action d-flex justify-content-between align-items-center"
             draggable="true" data-contact="samas">
            <div><span class="counter">{{ forloop.counter }}</span>. <i>Service Samaritains</i></div>
            <a href="{% url 'client-samaritains' client.pk %}" class="openmodal" title="Attribution des samaritains">
                <span class="badge bg-primary rounded-pill samas-count" title="Nombre de samaritains liés à ce client">{{ samas_count }}</span>
            </a>
            <form method="post" action="{% url 'client-setsamas' client.pk %}" class="ajax">{% csrf_token %}
                <button class="btn btn-sm btn-outline-secondary pb-0 pt-0" id="remove_samas"
                        data-confirm="Voulez-vous vraiment enlever le service des Samaritains ?">Enlever</button>
            </form>
        </div>
        {% else %}
        <div class="list-group-item list-group-item-action d-flex justify-content-between pe-1 {% if contact.contact_visites %}contact-visites{% endif %}"
             draggable="true" data-contact="{{ contact.pk }}">
             <div>
                <span class="counter">{{ forloop.counter }}</span>.
               {{ contact.get_full_name }}{% if contact.complement %}, {{ contact.complement }}{% endif %}, {{ contact.rue_localite }}<br>
               {% if contact.relation %}{{ contact.relation }} - {% endif %}
               {% for tel in contact.telephones %}
                 <span class="ms-2">{{ tel.tel|as_tel }}{% if tel.remarque %} ({{ tel.remarque }})</span>{% endif %}
               {% endfor %}
               {{ contact.courriel|as_email_icon }}
               {% if contact.recoit_courrier and not contact.courrier_envoye %}
                  <img src="{% static 'img/warning.svg' %}" class="courrier_non_envoye" data-bs-toggle="tooltip" title="Le courrier initial n’a pas encore été envoyé pour cette personne">
               {% endif %}
               {% if contact.autres_fonctions %}
                <br><span class="referent-fonction">{{ contact.autres_fonctions }}</span>
               {% endif %}
             </div>
             {% if not readonly %}
             <a href="{% url 'client-referent-edit' client.pk contact.pk %}" class="openmodal ps-3 pe-3"
                title="Édition du contact"
                data-deleteurl="{% url 'client-referent-delete' client.pk contact.pk %}"
                data-deletemethod="get">
                    <img src="{% static 'img/edit.svg' %}" class="icon h-100">
             </a>
             {% endif %}
        </div>
        {% endif %}
    {% endfor %}
    {% if client.pk and not client.samaritains and not readonly %}
    <div id="add-samas-button" class="mb-3 mt-2">
        <form method="post" action="{% url 'client-setsamas' client.pk %}" class="ajax">{% csrf_token %}
            <button class="btn btn-sm btn-outline-secondary immediate_submit" id="id_samaritains"
                    title="Ajouter les Samaritains comme répondants"
                    data-confirm="Voulez-vous vraiment ajouter les Samaritains comme répondants ?">
                + Samaritains comme répondants</button>
        </form>
    </div>
    {% endif %}
</div>

{% if referents %}
<h4>Personne-s de référence à prévenir en cas d'urgence :</h4>
<div class="list-group contact-list-orderable" data-reorder="{% url 'client-referent-reorder' client.pk %}"
     data-confirm="Souhaitez-vous vraiment changer l’ordre des personnes de référence ? La modification sera immédiatement enregistrée.">
    {% for contact in referents %}
        <div class="list-group-item list-group-item-action d-flex justify-content-between pe-1 {% if contact.contact_visites %}contact-visites{% endif %}"
             draggable="true" data-contact="{{ contact.pk }}">
             <div>
               <span class="counter">{{ forloop.counter }}</span>. {{ contact.get_full_name }}{% if contact.complement %}, {{ contact.complement }}{% endif %}, {{ contact.rue_localite }}<br>
               {% if contact.relation %}{{ contact.relation }} - {% endif %}
               {% for tel in contact.telephones %}
                 <span class="ms-2">{{ tel.tel|as_tel }}{% if tel.remarque %} ({{ tel.remarque }})</span>{% endif %}
               {% endfor %}
               {{ contact.courriel|as_email_icon }}
               {% if contact.recoit_courrier and not contact.courrier_envoye %}
                  <img src="{% static 'img/warning.svg' %}" class="courrier_non_envoye" data-bs-toggle="tooltip" title="Le courrier initial n’a pas encore été envoyé pour cette personne">
               {% endif %}
               {% if contact.autres_fonctions %}
                <br><span class="referent-fonction">{{ contact.autres_fonctions }}</span>
               {% endif %}
            </div>
            {% if not readonly %}
            <a href="{% url 'client-referent-edit' client.pk contact.pk %}" class="openmodal ps-3 pe-3"
                title="Édition du contact"
                data-deleteurl="{% url 'client-referent-delete' client.pk contact.pk %}"
                data-deletemethod="get">
                    <img src="{% static 'img/edit.svg' %}" class="icon h-100">
            </a>
            {% endif %}
        </div>
    {% endfor %}
</div>
{% endif %}

{% if autres_contacts %}
<h4>Autres contacts :</h4>
<div class="list-group contact-list">
    {% for contact in autres_contacts %}
        <div class="list-group-item list-group-item-action d-flex justify-content-between pe-1 {% if contact.contact_visites %}contact-visites{% endif %}"
             draggable="true" data-contact="{{ contact.pk }}">
             <div>
               {{ contact.get_full_name }}{% if contact.complement %}, {{ contact.complement }}{% endif %}, {{ contact.rue_localite }}<br>
               {% if contact.relation %}{{ contact.relation }} - {% endif %}
               {% for tel in contact.telephones %}
                 <span class="ms-2">{{ tel.tel|as_tel }}{% if tel.remarque %} ({{ tel.remarque }})</span>{% endif %}
               {% endfor %}
               {{ contact.courriel|as_email_icon }}
               {% if contact.recoit_courrier and not contact.courrier_envoye %}
                  <img src="{% static 'img/warning.svg' %}" class="courrier_non_envoye" data-bs-toggle="tooltip" title="Le courrier initial n’a pas encore été envoyé pour cette personne">
               {% endif %}
               {% if contact.autres_fonctions %}
                <br><span class="referent-fonction">{{ contact.autres_fonctions }}</span>
               {% endif %}
            </div>
            {% if not readonly %}
            <a href="{% url 'client-referent-edit' client.pk contact.pk %}" class="openmodal ps-3 pe-3"
                title="Édition du contact"
                data-deleteurl="{% url 'client-referent-delete' client.pk contact.pk %}"
                data-deletemethod="get">
                    <img src="{% static 'img/edit.svg' %}" class="icon h-100 opacity-75">
            </a>
            {% endif %}
        </div>
    {% endfor %}
</div>
{% endif %}

client/templates/client/fichier_list.html
<div class="col">
{% for fichier in fichiers %}
    <div class="mb-2" data-fileid="{{ fichier.pk }}" data-deleteurl="{% url 'client-fichier-delete' fichier.pk %}">
        <img src="{{ fichier.icon }}" class="ficon"> <a href="{{ fichier.fichier.url }}">{{ fichier.titre }}</a>
        <small><i>({{ fichier.quand|date:'d.m.Y' }}, par {{ fichier.qui.get_full_name }})</i></small>
        {% if not form.readonly %}
        <span class="delete-link"><img src="{% static 'admin/img/icon-deletelink.svg' %}"></span>
        {% endif %}
    </div>
{% endfor %}
</div>